---
title: IDBRequest.source
slug: Web/API/IDBRequest/source
tags:
  - API
  - Database
  - IDBRequest
  - IndexedDB
  - Property
  - Reference
  - Storage
  - source
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>source</code></strong> read-only property of the {{domxref("IDBRequest")}} interface returns the source of the request, such as an Index or an object store. If no source exists (such as when calling {{domxref("indexedDB.open")}}), it returns null.</p>

<p>{{AvailableInWorkers}}</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>IDBIndex</em> = <em>request</em>.source;
var <em>IDBCursor</em> = <em>request</em>.source;
var <em>IDBObjectStore</em> = <em>request</em>.source;
</pre>

<h2 id="Value" style="line-height: 30px; font-size: 2.14285714285714rem;">Value</h2>

<p>An object representing the source of the request, such as an {{domxref("IDBIndex")}}, {{domxref("IDBObjectStore")}} or {{domxref("IDBCursor")}}.</p>

<h2 id="Example">Example</h2>

<p>The following example requests a given record title, <code>onsuccess</code> gets the associated record from the {{domxref("IDBObjectStore")}} (made available as <code>objectStoreTitleRequest.result</code><span style="line-height: 1.5;">), updates one property of the record, and then puts the updated record back into the object store in another request. The source of the 2nd request is logged to the developer console. For a full working example, see our </span><a href="https://github.com/mdn/to-do-notifications/" style="line-height: 1.5;">To-do Notifications</a><span style="line-height: 1.5;"> app (</span><a href="https://mdn.github.io/to-do-notifications/" style="line-height: 1.5;">view example live</a><span style="line-height: 1.5;">.)</span></p>

<pre class="brush: js;highlight:[11]" style="font-size: 14px;">var title = "Walk dog";

// Open up a transaction as usual
var objectStore = db.transaction(['toDoList'], "readwrite").objectStore('toDoList');

// Get the to-do list object that has this title as its title
var objectStoreTitleRequest = objectStore.get(title);

objectStoreTitleRequest.onsuccess = function() {
  // Grab the data object returned as the result
  var data = objectStoreTitleRequest.result;

  // Update the notified value in the object to "yes"
  data.notified = "yes";

  // Create another request that inserts the item
  // back into the database
  var updateTitleRequest = objectStore.put(data);

  <span style="font-size: 1rem;">// Log the source of this request</span>
  console.log("The source of this request is " + updateTitlerequest.source);
  // When this new request succeeds, run the displayData()
  // function again to update the display
<span style="font-size: 1rem;">  updateTitleRequest</span><span style="font-size: 1rem;">.onsuccess = function() {</span> displayData(); };
};

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbrequest-source', 'source')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbrequest-source", "source")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBRequest.source")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
